# Redshift

## Anything in, anywhere out

Redshift is a JavaScript UX framework. It can be used for animations, UI physics, and input tracking.

It provides DOM support for ease-of-use but provides the ability to work with raw numbers and custom callbacks for total creative freedom. On the web, on the server, anywhere.

[Download](http://redshiftjs.com/download) | [API](http://redshiftjs.com/api) | [Guides](http://redshiftjs.com/guides/get-started) | [Twitter](http://twitter.com/redshiftjs)

**Flexible**
* Animate any property without waiting for explicit support.
* Seamless hand-off between user input, animation and physics.
* Work with your favourite technology or framework (DOM, Node, jQuery, Canvas, Three.js, WebSockets etc).

**Extendable**
* Create custom Input handlers for Oculus/Leap/anything.
* Add custom easing bezier curves.
* Expand our native DOM attr and CSS support with your own custom value input/output routes.

**Performant**
* Uses and exposes a single requestAnimationFrame thread.
* Never hits the DOM, leaving you in total control of performance.
* Over 20% smaller than Velocity.js, 72% smaller than GreenSock TweenMax. Boom shak shakalaka.


[Get started](http://redshiftjs.com/guides/get-started)
